	import * as THREE from 'three';

	// Vacuum rack
	export function rv(param) {
		const width=800, height=2500, depth=800;
		const rv = new THREE.Object3D();
		const rv_rackObject = new THREE.Object3D();

		const materialBase = new THREE.MeshLambertMaterial({color: 0x0000d0});
		const text = param.name;
		let group, textMesh, textGeo, materials;
		let size = 60;
		let textheight = 10;
		let pos = [];
		let rot = [];
		const hover = 30;
		const curveSegments = 8;
		let font;
		function insertText(isize, ipos, irot) {
			group = new THREE.Group();
			group.position.y = 100;
			rv.add( group );
			size = isize;
			pos = ipos;
			rot = irot;
			loadFont();
		}
		function loadFont() {
			const loader = new FontLoader();
			// https://threejs.org/examples/fonts/droid_sans_bold.typeface.json
			loader.load( './fonts/droid_sans_bold.typeface.json', function ( response ) {
				font = response;
				refreshText();
			} );
		}
		function createText() {
			textGeo = new TextGeometry(text, {font: font, size: size, height: textheight, curveSegments: curveSegments});
			textGeo.computeBoundingBox();
			const centerOffset = -0.5 * (textGeo.boundingBox.max.x - textGeo.boundingBox.min.x);
			textMesh = new THREE.Mesh(textGeo, materialBase);
			textMesh.position.x = pos[0];
			textMesh.position.y = pos[1];
			textMesh.position.z = pos[2];
			textMesh.rotation.x = rot[0];
			textMesh.rotation.y = rot[1];
			textMesh.rotation.z = rot[2];
			group.add( textMesh );
		}
		function refreshText() {
			group.remove( textMesh );
			if ( ! text ) return;
			createText();
		}
		insertText(50, [850, 2330, 550], [0, Math.PI / 2, 0]);
	
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		
		// rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		//rrmesh.position.set( 0, 0 , -810);
		rv_rackObject.add(rrmesh);
		
		//front yellow tag
		const Ftarget = new THREE.BoxGeometry(2, 90, 400);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -5);
		rv_rackObject.add(Ftargetmesh);		
		//Rear yellow tag
		const Rtarget = new THREE.BoxGeometry(2, 90, 400);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -5);
		rv_rackObject.add(Rtargetmesh);				
		
		//edge lle	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -365);
		rv_rackObject.add(llemesh);
		
		//edge lre		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 380);
		rv_rackObject.add(lremesh);		

		//edge lue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , 3);
		rv_rackObject.add(luemesh);		

		//edge lde		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , 3);
		rv_rackObject.add(ldemesh);				
		
		//base PS ionic Pump
		const drawer1geometry = new THREE.BoxGeometry(10, 2450, 750);
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/rvscreenfoto.jpg');
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(1, 1);
		const material = new THREE.MeshBasicMaterial({ map: texture });
		const materials = [bluematerial, material, bluematerial, bluematerial, bluematerial, bluematerial];
		const gridgeometrymesh = new THREE.Mesh(drawer1geometry, materials);
		gridgeometrymesh.rotateX(Math.PI * 1);
		gridgeometrymesh.rotateY(Math.PI * 1);
		gridgeometrymesh.rotateZ(Math.PI * 1);
		gridgeometrymesh.position.set( -400, 0 , 0);
		rv_rackObject.add(gridgeometrymesh);		

		rv_rackObject.rotateY(Math.PI);
		rv_rackObject.position.set(400, 1250, 400);
		rv.add(rv_rackObject);
		return rv;
	}
